module Day8Lib
  ( lVisible,
    rScore,
    --
    processInput1,
    processInput2,
  )
where

import Data.List
import Debug.Trace

lVisible :: [Int] -> [Bool]
lVisible = lVisible' (-1)

lVisible' :: Int -> [Int] -> [Bool]
lVisible' m [] = []
lVisible' m (e : r) = (e > m) : lVisible' (max e m) r

rScore :: [Int] -> [Int]
rScore [] = []
rScore (a : r) = rVisible a r : rScore r

rVisible :: Int -> [Int] -> Int
rVisible h (a : r)
  | a >= h = 1
  | a < h = 1 + rVisible h r
  | otherwise = error "what are numbers"
rVisible _ [] = 0

-- ####################

processInput1 :: String -> Int
processInput1 input =
  let trees = map (map (read . (: []))) . lines $ input :: [[Int]]
      hVisible = findVisible trees
      tTrees = transpose trees
      vVisible = findVisible tTrees
      visible = zipWith (zipWith (||)) hVisible (transpose vVisible)
   in sum . map (length . filter id) $ visible

findVisible = map (\x -> zipWith (||) (lVisible x) (reverse . lVisible . reverse $ x))

processInput2 :: String -> Int
processInput2 input =
  let trees = map (map (read . (: []))) . lines $ input :: [[Int]]
      hScores = hScore trees
      vScores = transpose . hScore . transpose $ trees
      scores = zipWith (zipWith (*)) hScores vScores
   in maximum . concat $ scores

hScore = map (\x -> zipWith (*) (rScore x) (reverse . rScore . reverse $ x))