import Day10Lib (processInput1, processInput2)
import System.IO
import Test.HUnit

testCases1 =
  [ ("data/input100.txt", 13140),
    ("data/input101.txt", 17020)
  ]

testCase1 (file, result) = do
  withFile
    file
    ReadMode
    ( \handle -> do
        contents <- hGetContents handle
        assertEqual "input test" result $ processInput1 contents
    )

testCases2 =
  [ ( "data/input100.txt",
      "##..##..##..##..##..##..##..##..##..##..\n\
      \###...###...###...###...###...###...###.\n\
      \####....####....####....####....####....\n\
      \#####.....#####.....#####.....#####.....\n\
      \######......######......######......####\n\
      \#######.......#######.......#######....."
    ),
    ( "data/input101.txt",
      "###..#....####.####.####.#.....##..####.\n\
      \#..#.#....#.......#.#....#....#..#.#....\n\
      \#..#.#....###....#..###..#....#....###..\n\
      \###..#....#.....#...#....#....#.##.#....\n\
      \#.#..#....#....#....#....#....#..#.#....\n\
      \#..#.####.####.####.#....####..###.####." -- RLEZFLGE
    )
  ]

testCase2 (file, result) = do
  withFile
    file
    ReadMode
    ( \handle -> do
        contents <- hGetContents handle
        assertEqual ("input test: " ++ file) result $ processInput2 contents
    )

tests =
  TestList $
    [TestCase (testCase1 c) | c <- testCases1]
      ++ [TestCase (testCase2 c) | c <- testCases2]

main :: IO ()
main = do
  runTestTT tests
  return ()
