import qualified Data.Set as Set
import Day15Lib
import Test.HUnit
import Text.Parsec

parseTests =
  [ parse parseNumber "" "1"
      ~?= Right (1),
    parse parseNumber "" "-10"
      ~?= Right (-10),
    parseLine "Sensor at x=2, y=18: closest beacon is at x=-2, y=15"
      ~?= Sensor {position = Vector (2, 18), beacon = Vector (-2, 15)}
  ]

boundaryTests =
  [ generateBoundary Sensor {position = Vector (0, 0), beacon = Vector (0, 1)}
      ~?=
        [ Vector (0, 2),
          Vector (1, 1),
          Vector (2, 0),
          Vector (1, -1),
          Vector (0, -2),
          Vector (-1, -1),
          Vector (-2, 0),
          Vector (-1, 1)
        ]
  ]

tests =
  TestList $
    parseTests
      ++ boundaryTests
      ++ []

main :: IO ()
main = do
  runTestTT tests
  return ()
